/* #ident "$Id: main.c,v 1.2 2004/04/14 01:22:44 rzr Exp $" */
/**
 * @author: www.Philippe.COVAL.online.fr - Rev: $Author: rzr $ 
 * Copyright: GPL @ http://rzr.online.fr/licence.htm
 **/

#include "mini3d/mini3d.c"
#include "mini3dexport.c"

int loadScene3dsAsciiNorm( char* filename,  Scene* scene)
{
  int t=0;

  Vertex l,h;
  Vertex r = { 0, 0, 0 };
  Vertex s = { 1,1,1 };
  
  t = loadScene3dsAscii( filename , scene );   
  if ( t < 0 ) return EXIT_FAILURE;
  debug(". loaded");
  
  statsSceneBox( scene, &l, &h);      
  
  debug(". transform");
  l = addVV( h, l);
  l = multVf( l, -.5);
  
  r.x = -90;
  
  transformScene( scene, &l, &r ,&s);
  
  scaleSceneInSphere( scene , 1);
  statsSceneBox( scene, &l, &h);

  //l = multVf( l, -1);
  //h = r; 
  //h.y = l.y;
  
  //transformScene( scene, &h, &r ,&s);
  debug("- transform");
  
  return 0;
}


#ifndef LIB
int main(int argc, char* argv[])
{
  int t;
  Scene scene_;
  Vertex l,h;

  debugf("+ main %d \n",argc);
  //t = loadScene3dsAsciiNorm( argv[1] , &scene_ );   
  t = loadScene3dsAscii( argv[1] , &scene_ );   
  if ( t < 0 ) return EXIT_FAILURE;
  debug(". loaded");
  
  //statsSceneBox( &scene_, &l, &h);

  saveScene(&scene_, "/tmp/tmp-obj-3ds-tmp.asc");
  fprintScenePov( stdout, &scene_);
  saveScenePov(&scene_, "/tmp/tmp-obj-3ds-tmp.pov");
  //system("povray +P /tmp/tmp-obj-3ds-tmp.pov");
  return EXIT_SUCCESS;
}
#endif

/* #ident "$Id: main.c,v 1.2 2004/04/14 01:22:44 rzr Exp $" */
