#include "mini3dexport.h"

#ifndef scenesize  //!!!! TODO : remove
#define scenesize 16 // // cube settings :+16 =30*2 -31 // cross +29 64*2 
#define FPone  1024 // 65536 //1024 //65536;
#define tointf(x) ( (int) ( (x) * FPone + \
 ( ( x > 0 ) ? ( .5 )  : (- .5) ) ) )
#endif

int fprintSceneXML(FILE* f, Scene const * const  in)
{
  int t=0;
  unsigned int i=0;
  fprintf(f,"<?xml version=\"1.0\"?>\n");
  fprintf(f,"<scene>\n");
  fprintf(f,"<list>\n");
  for (i=0; i < in->no; i++) {
    t = fprintObjectXML( f, & (in->vo[i]) );
  }
  fprintf(f,"</list>\n");
  fprintf(f,"</scene>\n");
  return t;
}
/*
  http://www.web3d.org/TaskGroups/x3d/blaxxun/x3d/html/xml.html
*/
int fprintObjectXML(FILE* f, Object const * const  o)
{
  unsigned int i=0;
  fprintf(f,"\n<object");
  if ( o->name) fprintf(f," name=\"%s\"",o->name);
  else  fprintf(f," name=\"unknown\"");
  fprintf(f," vertices=\"%d\" faces=\"%d\"", o->nv, o->nf);
  
  fprintf(f,">\n\n");
  fprintf(f,"<vertices count=\"%d\">\n",o->nv);
  for(i=0;i<o->nv;i++) {
    fprintf( f," <vertex> %f %f %f </vertex>\n",
             o->vv[i].x, o->vv[i].y , o->vv[i].z);
  }
  fprintf(f,"</vertices>\n");
  fprintf(f,"\n<faces count=\"%d\">\n",o->nf);
  for(i=0;i<o->nf;i++) {
    fprintf( f,"<face count=\"3\">\n");
    fprintf(f,"<vertexid id=\"%d\" /> \n",o->vf[i].a);
    fprintf(f,"<vertexid id=\"%d\" /> \n",o->vf[i].b);
    fprintf(f,"<vertexid id=\"%d\" /> \n",o->vf[i].c);
    fprintf( f,"</face>\n");
  }
  fprintf(f,"</faces>\n");
  fprintf(f,"\n</object>\n");
  return 1;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int fprintSceneXMLBin(FILE* f, Scene const * const  in)
{
  int t=0;
  unsigned int i=0;
  fprintf(f,"<?xml version=\"1.0\"?>\n");
  fprintf(f,"<scene>\n");
  fprintf(f,"<list>\n");
  for (i=0; i < in->no; i++) {
    t = fprintObjectXMLBin( f, & (in->vo[i]) );
  }
  fprintf(f,"</list>\n");
  fprintf(f,"</scene>\n");
  return t;
}

int fprintObjectXMLBin(FILE* f, Object const * const  o)
{
  unsigned int i=0;
  fprintf(f,"\n<object");
  if ( o->name) fprintf(f," name=\"%s\"",o->name);
  else  fprintf(f," name=\"unknown\"");
  fprintf(f," vertices=\"%d\" faces=\"%d\"", o->nv, o->nf);
  
  fprintf(f,">\n\n");
  fprintf(f,"<vertices format=\"3f\" count=\"%d\">",o->nv);
  for(i=0;i<o->nv;i++) {
    fwrite( &(o->vv[i].x),sizeof( o->vv[i].x ),1,f);
    fwrite( &(o->vv[i].y),sizeof( o->vv[i].y ),1,f);
    fwrite( &(o->vv[i].z),sizeof( o->vv[i].z ),1,f);
  }
  fprintf(f,"</vertices>\n");
  fprintf(f,"\n<faces format=\"3i\" count=\"%d\">",o->nf);
  for(i=0;i<o->nf;i++) {
    fwrite( &(o->vf[i].a),sizeof( o->vf[i].a ),1,f);
    fwrite( &(o->vf[i].b),sizeof( o->vf[i].b ),1,f);
    fwrite( &(o->vf[i].c),sizeof( o->vf[i].c ),1,f);
  }
  fprintf(f,"</faces>\n");
  fprintf(f,"\n</object>\n");
  return 1;
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int fprintObjectPov(FILE* f, Object const * const  o)
{
  unsigned int i=0;
  fprintf(f,"\n//");
  if ( o->name) fprintf(f,"%s",o->name);
  else
    fprintf(f,"%dV_%dF_@_www.rzr.online.fr", o->nv, o->nf);
  
  fprintf(f,"\n");
  fprintf(f,"mesh2 {\n");
  fprintf(f,"vertex_vectors {\n");
  fprintf(f,"%d, \n",o->nv);
  for(i=0;i<o->nv - 1 ;i++) {
    fprintf( f," < %f,%f,%f>,\n",
	     o->vv[i].x,  o->vv[i].y, o->vv[i].z);
  }
  i = o->nv - 1;
  fprintf( f," < %f,%f,%f> \n",
           o->vv[i].x,  o->vv[i].y, o->vv[i].z);
  fprintf(f,"} \n");
  fprintf(f,"face_indices  {\n");
  fprintf(f," %d, \n",o->nf);
  for(i=0;i<o->nf - 1;i++) {
    fprintf( f," < %d,%d,%d>,\n",
	     o->vf[i].a,  o->vf[i].b, o->vf[i].c);
  }
  i = o->nv - 1;
  fprintf( f," < %d,%d,%d>\n",
           o->vf[i].a,  o->vf[i].b, o->vf[i].c);
  fprintf(f,"} \n");
  fprintf(f,"} //-mesh \n");
  return 1;
}
int fprintScenePov(FILE* f, Scene const * const  in)
{
  int t=0,i=0;
  fprintf(f,"#include \"render.inc\" \n");
  fprintf(f,"#declare _Pv= <2,3,-4>;  \n");
  
  for (i=0; i < in->no; i++)
    t = fprintObjectPov( f, & (in->vo[i]) );
  return t;
}

int saveScenePov( Scene const * const in, char const * const filename)
{
  int t=0;
  FILE *f=0;
  f=fopen( (const char*) filename, "wb"); //!
  if ( ! f ) return (int) f;
  return fprintScenePov( f, in);
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/*
  Facette
  {
  Point { X=-1; Y=-1; Z=1; }
  Point { X=1; Y=-1; Z=1; }
  Point { X=1; Y=1; Z=1; }
  }

  http://rwvsndj.tuxfamily.org/site/index.php?lang=fr&rub=about-objects

*/


int fprintSceneNdj(FILE* f, Scene const * const  in)
{
  int t=0,i=0;  
  //fprintf(f,"Scene { \n");
  for (i=0; i < in->no; i++) {
    t = fprintObjectNdj( f, & (in->vo[i]) );
  }
  //fprintf(f,"}\n");  
  return t;
}


int fprintObjectNdj(FILE* f, Object const * const  o)
{
  unsigned int i=0;
  Face face;
  Vertex v;
  //fprintf(f,"\n//");
  
  //  if ( o->name) fprintf(f,"%s",o->name);
  //else
  //fprintf(f,"%dV_%dF_@_mini3d", o->nv, o->nf);
  //fprintf(f,"Object { \n");

  
  for(i=0;i<o->nf - 1;i++) {

    face = o->vf[i];
    if ( face.material ) fprintf(f,"Texture=\"%s\";\n",face.material);

    fprintf( f,"Facette { \n");
    v = o->vv[ face.a ];  
    fprintf( f,"\tPoint { X=%f; Y=%f; Z=%f; ", v.x, v.y , v.z);
    fprintf( f,"TX=%f; TY=%f;", v.u , v.v );
    fprintf( f," }\n");

    v = o->vv[ face.c ];  
    fprintf( f,"\tPoint { X=%f; Y=%f; Z=%f; ", v.x, v.y , v.z);
    fprintf( f,"TX=%f; TY=%f;", v.u , v.v );
    fprintf( f," }\n");

    v = o->vv[ face.b ];  
    fprintf( f,"\tPoint { X=%f; Y=%f; Z=%f; ", v.x, v.y , v.z);
    fprintf( f,"TX=%f; TY=%f;", v.u , v.v );
    fprintf( f," }\n");

    fprintf( f,"} \n"); // Facette
  }
  fprintf(f,"}\n");
  return 1;
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int fprintSceneLangC(FILE* f, Scene const * const  in)
{
  int t=0,i=0;  
  fprintf(f,"//Scene { \n");
  for (i=0; i < in->no; i++) {
    fprintf(f,"//Object { \n");
    t = fprintObjectLangC( f, & (in->vo[i]) );
    fprintf(f,"//}\n");
  }
  fprintf(f,"//}\n");  
  return t;
}


int fprintObjectLangC(FILE* f, Object const * const  o)
{
  unsigned int i=0;
  fprintf(f,"// Named object: \"");
  if ( o->name) fprintf(f,"%s",o->name);
  else
    fprintf(f,"%dV_%dF_@_www.rzr.online.fr", o->nv, o->nf);
  
  fprintf(f,"\n");
  fprintf(f,"int nv=%d; int nf=%d;\n",o->nv, o->nf);
  //fprintf(f,"{ //float vv[%d][3]= { \n",o->nf);
  fprintf(f,"double vv[%d][3]= { \n",o->nf);
  for(i=0;i<o->nv-1;i++) 
    fprintf( f," { %f, %f, %f }, ",
             o->vv[i].x,  o->vv[i].y, o->vv[i].z);
  
  fprintf( f," { %f, %f, %f } \n};\n;",
           o->vv[i].x,  o->vv[i].y, o->vv[i].z);
  
  return 1;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int fprintSceneLangJava(FILE* f, Scene * const  in)
{
  int t=0,i=0;  
  centerObject( &((*in).vo[0]) );
  scaleSceneInSphere( in , scenesize ); //!
  centerObject( &((*in).vo[0]) );

  fprintf(f,"//Scene { \n");
  for (i=0; i < in->no; i++) {
    fprintf(f,"//Object { \n");
    t = fprintObjectLangJava( f, & (in->vo[i]) );
    fprintf(f,"//} Object\n");
  }
  fprintf(f,"//} Scene\n");  
  return t;
}


int fprintObjectLangJava(FILE* f, Object const * const  o)
{
  unsigned int i=0;

  fprintf(f,"// Named object: \"");
  if ( o->name) fprintf(f,"%s",o->name);
  else
    fprintf(f,"%dV_%dF_@_www.rzr.online.fr\n", o->nv, o->nf);
  
  //  fprintf(f,"public final class Mesh {\n");
  fprintf(f,"public static final int mesh_nv=%d; public static final int mesh_nf=%d;\n",o->nv, o->nf);
  //fprintf(f,"{ //float vv[%d][3]= { \n",o->nf);
  fprintf(f,"public static final int mesh_vv[][]= { \n");
  for(i=0;i<o->nv-1;i++) 
    fprintf( f," { %d, %d, %d }, ",
             tointf(o->vv[i].x), tointf(o->vv[i].y) , tointf(o->vv[i].z) );
  
  fprintf( f," { %d, %d, %d } \n};\n",
           tointf(o->vv[i].x), tointf(o->vv[i].y) , tointf(o->vv[i].z) );

  fprintf(f,"public static final int mesh_vf[][]= { \n");
  for(i=0;i<o->nf-1;i++) 
    fprintf( f," { %d, %d, %d }, ",
             o->vf[i].a, o->vf[i].b, o->vf[i].c);
  fprintf( f," { %d, %d, %d } \n};\n",
           o->vf[i].a, o->vf[i].b, o->vf[i].c);
  

  fprintf(f,"public static final int mesh_vc[]= { \n");
  for(i=0;i<o->nf-1;i++) 
    fprintf( f," 0x%x, ",
             getColor( o->vf[i].material ) );

  fprintf( f," 0x%x };\n",
           getColor( o->vf[i].material ) );
  
  //fprintf(f,"} //class Mesh\n");
  return 1;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int fprintSceneVrml1(FILE* f, Scene const * const  in)
{
  int t=0,i=0;  
  fprintf(f,"#VRML V1.0 ascii\n");
  fprintf(f,"Separator{\n");// #ShapeHints {shapeType SOLID\nvertexOrdering COUNTERCLOCKWISE} SpotLight {on FALSE} PerspectiveCamera{ orientation 0 1 0 1.5708 position 4963 499 -3619 heightAngle 1.4776 } ");
  for (i=0; i < in->no; i++) {
    t = fprintObjectVrml1( f, & (in->vo[i]) );
  }
  fprintf(f,"} \n");
  return t;
}

int fprintObjectVrml1(FILE* f, Object const * const  o)
{
  unsigned int i=0;

  fprintf(f,"#Named object: \"");
  if ( o->name) fprintf(f,"%s",o->name);
  else
    fprintf(f,"%dV_%dF_@_www.rzr.online.fr\n", o->nv, o->nf);


  fprintf(f,"#t mesh_nv=%d; mesh_nf=%d;\n",o->nv, o->nf);


  fprintf(f,"Coordinate3{\n point [\n");
  for(i=0;i<o->nv-1;i++) 
    fprintf( f,"  %f %f %f , \n",
             o->vv[i].x, o->vv[i].y, o->vv[i].z );
  fprintf( f,"  %f %f %f  \n]\n}\n",
           o->vv[i].x, o->vv[i].y, o->vv[i].z );


  fprintf(f,"Separator{ IndexedFaceSet{ coordIndex[\n");
  for(i=0;i<o->nf-1;i++) 
    fprintf( f," %d, %d, %d , -1, \n ",
             o->vf[i].a, o->vf[i].b, o->vf[i].c);
  fprintf( f," %d, %d, %d , -1 \n]\n",
           o->vf[i].a, o->vf[i].b, o->vf[i].c);
  
  
  fprintf(f,"} #IndexFaxeSet\n");
  fprintf(f,"} #Sep\n");
  return 1;
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*
  geometry IndexedFaceSet {
  solid FALSE
  creaseAngle 0.785398
  coord Coordinate {
  point [
  -0.12 -0 0,
  -0.09 1.01 0,
  0.12 0.01 0]
  }

  coordIndex [
  2, 1, 0, -1]}
  }
  ]
  }
*/
int fprintSceneVrml2(FILE* f, Scene const * const  in)
{
  int t=0,i=0;  
  fprintf(f,"#VRML V2.0 utf8\n");
 <	//  fprintf(f,"Group { \n");
  for (i=0; i < in->no; i++) {
    t = fprintObjectVrml2( f, & (in->vo[i]) );
  }
//  fprintf(f,"}#Group\n");
  return t;
}

//TODO : ERR
int fprintObjectVrml2(FILE* f, Object const * const  o)
{
  unsigned int i=0;

  fprintf(f,"#Named object: \"");
  //if ( o->name) fprintf(f,"%s",o->name); else
  fprintf(f,"%dV_%dF_@_www.rzr.online.fr\n", o->nv, o->nf);


  fprintf(f,"#t mesh_nv=%d; mesh_nf=%d;\n",o->nv, o->nf);
  fprintf(f,"Shape {\n");

  fprintf(f,"geometry IndexedFaceSet {\ncoord Coordinate {\n point [\n");
  for(i=0;i<o->nv-1;i++) 
    fprintf( f," %f %f %f , \n",
             o->vv[i].x, o->vv[i].y, o->vv[i].z );
  fprintf( f," %f %f %f  \n]\n}\n",
           o->vv[i].x, o->vv[i].y, o->vv[i].z );
  
  fprintf(f,"coordIndex [\n");
  for(i=0;i<o->nf-1;i++) 
    fprintf( f," %d, %d, %d , -1, \n ",
             o->vf[i].a, o->vf[i].b, o->vf[i].c); // CHECK if rev or not
  fprintf( f," %d, %d, %d , -1 \n]\n",
           o->vf[i].a, o->vf[i].b, o->vf[i].c );
  
  
  fprintf(f,"} #IndexFaxeSet\n");
  fprintf(f,"} #Shape\n");
  return 1;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
