/* #ident "$Id: mini3dviewglut.c,v 1.1.1.1 2004/03/30 12:09:35 rzr Exp $" */
/**
 * @author: www.Philippe.COVAL.online.fr - Rev: $Author: rzr $ 
 * Copyright: GPL @ http://rzr.online.fr/licence.htm
 **/

#include <GL/glut.h>
#include <stdlib.h>
#include "mini3d/mini3d.h"
#include "mini3d/mini3d.c"
#include "mini3d-tools/mini3dgl.c"

//#define LIB
//#include "main.c"


#ifndef debugf
#define debugf printf
#define debug(x) debugf("%s\n",x)
#endif

static Scene scene_ ;


//---
void init(void) 
{
  glClearColor (0.0, 0.0, 0.0, 0.0);
  glShadeModel(GL_LINES); // GL_FLAT
  
  //gluLookAt (0.0, 0.0, 3.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
  
  glDepthFunc(GL_LEQUAL); glEnable(GL_DEPTH_TEST);
  //glEnable(GL_TEXTURE_2D);
  glPushMatrix();
  
  debug("- init");
}

void display(void) 
{
  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  trace(&scene_);
  glFlush ();  
  /* debug("- display"); */
}

void reshape (int w, int h) 
{

  glViewport (0, 0, (GLsizei) w, (GLsizei) h);
  //glMatrixMode (GL_PROJECTION);
  //glLoadIdentity ();
  //glFrustum (-1.0, 1.0, -1.0, 1.0, 1.5, 20.0);
  //glMatrixMode (GL_MODELVIEW);

  debug("- reshape");
}

void keyboard(unsigned char key, int x, int y)
{
  float angle=10;
  float step=0.1;
  
  //debug("+ keyboard");
  
  glMatrixMode( GL_MODELVIEW);
  switch (key) {
  case 27 :    exit( EXIT_SUCCESS);    break;
  case 'g':    glRotatef( angle ,1,0,0);   break;
  case 'G':    glRotatef( - angle ,1,0,0);   break;
  case 'h':    glRotatef( angle ,0,1,0);    break;
  case 'H':    glRotatef( - angle ,0,1,0);    break;
  case 'j':    glRotatef( angle ,0,0,1);    break;
  case 'J':    glRotatef( - angle ,0,0,1);    break;
  case 't':    glTranslatef( step, 0,0);    break;
  case 'T':    glTranslatef( - step, 0,0);    break;
  case 'y':    glTranslatef( 0,step,0);    break;
  case 'Y':    glTranslatef( 0,- step,0);    break;
  case 'u':    glTranslatef( 0,0,step);    break;
  case 'U':    glTranslatef( 0,0, - step);    break;
  case 'k':    glLoadIdentity();    break;
  case 'w':    glPolygonMode(GL_FRONT_AND_BACK,GL_LINE); break;
  case 'W':    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL); break;
  }
  glutPostRedisplay();
  /* debug("- keyboard"); */
}

int main(int argc, char** argv)
{
  int t=0;
  
  int w=200, h=200;
  debug("+ main");
  
  //t = loadScene3dsAsciiNorm( argv[1] , &scene_ );   
  t = loadScene3dsAscii( argv[1] , &scene_ );   
  if ( t < 0 ) return EXIT_FAILURE;
  scaleSceneInSphere( &scene_ , 1);
  
  glutInit(&argc, argv);
  glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB | GLUT_DEPTH );
  glutInitWindowSize (w, h);
  glutInitWindowPosition (0, 0);
  glutCreateWindow (argv[0]);
  init ();
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(keyboard);
  glutMainLoop();
  return EXIT_SUCCESS;
  debug("- main");
  
}

/* EOF */

