/* #ident "$Id: color3ds.c,v 1.1.1.1 2004/03/30 12:09:25 rzr Exp $" */
/**
 * @author: www.Philippe.COVAL.online.fr - Rev: $Author: rzr $ 
 * Copyright: GPL @ http://rzr.online.fr/licence.htm
 **/

#ifndef color3ds_c_ 
#define color3ds_c_ 
#include "include.h"
#include "color3ds.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define float2char(x) ( ( unsigned char) ( (x) * 255.) )
#define char2float(x) ( ( (unsigned char) (x)) / 255. )
#define toUint32(r,g,b) ( (r<<16) + (g<<8) + b )
#define blue(x) ( (x) & 0x0000FF )
#define green(x) ( (x>>8) & 0x0000FF )
#define red(x) ( (x>>16) & 0x0000FF )
#define alpha(x) ( (x>>24) & 0x0000FF )

int convertColorUint32ToRGB(unsigned int const src, char* dest)
{
  char r= src & 0xFF;
  char g= (src>>8) & 0xFF;
  char b= (src>>18) & 0xFF;
  char a= (src>>24) & 0xFF;
  
  //debugf("r%dg%db%da%d", r,g,b,a);
  sprintf(dest,"r%dg%db%da%d", r,g,b,a);
  return 0;
}

int convertColorRGBFloatToString(const float r, const float g, const float b,
                                 const float a, char* dest)
{
  unsigned char cr,cg,cb,ca=0;
  cr= float2char(r);
  cg= float2char(g);
  cb= float2char(b);
  ca= float2char(a);
  dest="r255g255b255a000";
  //debugf("r%dg%db%da%d\0",cr,cg,cb,ca);
  exit(0);
  return 0;
}


int convertColorToRGB(unsigned int const src,
                      unsigned  char* r, unsigned char* g,unsigned  char* b)
{
  //debug("+ convertColorToRGB");
  *b =  src & 0x0000FF;
  *g = (src>>8) & 0x0000FF;
  *r = (src>>16) & 0x0000FF;
  //debugf("%x={%x,%x,%x};\n",src,*r,*g,*b); //check here
  //  exit(0);
  return 0;
}

int convertColorToRGBFloat(unsigned int const src, 
                           float* r, float* g, float* b, float *a)
{
  *b = (float) ( src & 0x0000FF ) / 255.; 
  *g = (float) ( (src>>8) & 0x0000FF ) / 255.; 
  *r = (float) ( (src>>16) & 0x0000FF ) / 255.;
  *a = alpha( src);
  //debugf("%x={%f,%f,%f};\n",src,*r,*g,*b);
  return 0;
}

int convertColorRGBFloatToAnsi(float const r, float const g, float const b,
                               int * res) 
{
  //debugf("TODO");
  *res=(int)( r+g+b );
  exit(0);
 return *res;
}


int convertColorStringRGBAToRGBA8(char const * const p,
                                  unsigned char *r, unsigned char* g,
                                  unsigned char *b, unsigned char* a,
                                  unsigned int* dest)
{
  //debugf("+ getColorEncoded \"%s\"\n",p);
  int ret=-1;
  char * pb=0, * pe =0;
  *dest=0xFFFFFF;
  *r = *g = *b = *a = 255;
  assert(p);
  //debug(".todo regexp on paterns like \"r27g88b176a0\"");
  //sscanf("r%dg%db%d", &r, &g, &b); // &tmpr, &r, &tmpg,g &tmpb, &b, p);

  if ( *p=='r' && strstr(p,"g") && strstr(p,"b") && strstr(p,"a") ) {
    pb = strstr(p,"r") +1;
    pe = strstr(pb,"g");
    if ( ! pe ) return -1;
    //assert(pe);
    *r = atoi(pb);
    pb = pe + 1;
    pe = strstr(pb,"b");
    if ( ! pe ) return -1;
    *g = atoi(pb);
    pb = pe + 1;
    pe = strstr(pb,"a");
    if ( ! pe ) return -1;
    *b = atoi(pb);
    pb = pe + 1;
    *a = atoi(pb);
    ret=1;
  }
  *dest = toUint32(*r,*g,*b);
  //debug("- convertColorStringRGBAToRGBA8");
  return ret;
}

int convertColorStringRGBAToRGBAFloat(char const * const p,
                                      float *r, float* g, float* b, float* a,
                                      unsigned int* dest)
{
unsigned  char cr,cg,cb,ca;
  convertColorStringRGBAToRGBA8(p, &cr,&cg,&cb,&ca,dest);
  *r = char2float(cr);
  *g = char2float(cg);
  *b = char2float(cb);
  *a = char2float(ca);
  //debug("+ convertColorStringRGBAToRGBAFloat");
  return 0;
}



int getColorTable(char const * const p, unsigned int * dest)
{
  //debugf("+ getColorTable \"%s\"\n",p);
  *dest = 0xFFFFFF;
  if ( p == 0 ) return -1;
  if ( strstr( p, "BLACK") ) {  *dest = 0x000000;  }
  else if ( strstr( p, "WHITE") ) {  *dest = 0xFFFFFF;  }
  else if ( strstr( p, "BLUE") ) { *dest = 0x0000FF; }
  else if ( strstr( p, "GREEN") ) { *dest = 0x00FF00; }
  else if ( strstr( p, "RED") ) { *dest = 0xFF0000;} 
  else if ( strstr( p, "CYAN") ) {  *dest = 0x00FFFF;  }
  else if ( strstr( p, "MAGENTA") ) {*dest = 0xFF00FF;  } 
  else if ( strstr( p, "YELLOW") ) {    *dest = 0xFFFF00;  }
  else if ( strstr( p, "GRAY") ) { *dest = 0xFFFFFF; }
  else { return -1; }
  // GREENBUG, COW,  etc
  //debugf("- getColorTable (%x)\n",*dest);
  return 0;
}


int convertColorStringToRGBAFloat(char const * const p,
                                  float *r, float* g, float* b, float* a,
                                  unsigned int* dest)
{
  unsigned char cr=255,cg=255,cb=255,ca=0;
  unsigned int ret=0xFFFFFF;
  int t=-1;
  
  //debugf("+ convertColorStringToRGBAFloat \"%s\"\n",p);
  *r = *g = *b = 1.; *a=0.; 
  *dest = ret;
  if ( p == 0 ) return -1;
  t = getColorTable(p, &ret );
  
  if( t >= 0 ) {
    cr=red(ret);    cg=green(ret);    cb=blue(ret);    ca=alpha(ret);
  } else 
    if (  ( *p=='r' && strstr(p,"g") && strstr(p,"b") && strstr(p,"a") ) ) {
      t = convertColorStringRGBAToRGBA8(p,&cr,&cg,&cb,&ca,&ret);
    }
  if ( t < 0 ) { //debugf("!!! Err/ Not Found \"%s\"\n",p); 
    return t; 
  }
  //debugf("%s={%u,%u,%u,%u}=%x\n",p,cr,cg,cb,ca,ret);  
  // assert(t);

  *r = char2float( cr);
  *g = char2float( cg); 
  *b = char2float( cb);
  *a = char2float( ca);
  *dest = ret;
  
  //debugf("%s={%f,%f,%f,%f}=%x\n",p,*r,*g,*b,*a,*dest);  
  //debugf("- convertColorStringToRGBAFloat \"%s\"\n",p);
  return 0;
}
//----------------------------------------------------------------------------
unsigned int getColor(char const * const p)
{ 
  unsigned char r=0,g=0,b=0,a=0;
  unsigned int ret=0xFFFFFF;
  int t=0;
  
  //debugf("+getColor \"%s\"\n",p);
  if ( p == 0 ) return ret;
  r= g = b = 0;
  if( getColorTable(p, &ret ) >= 0 ) return ret;
  if ( *p != 'r' )  return ret;
  t = convertColorStringRGBAToRGBA8(p,&r,&g,&b,&a,&ret);
  if ( t < 0 ) { ; //debugf("!!! Err/ Not Found \"%s\"\n",p);  
  }
  
  // assert(t);
  convertColorToRGB(ret, &r, &g, &b );
  //debugf("%s={%u,%u,%u}=%x\n",pb,r,g,b,ret);  
  return ret;
}


unsigned int getColorRGBFloat(float* r, float*g, float*b, float*a,
                              char const * const p) 
{
  //debug("+getColorRGBFloat");
  unsigned int c=0;
  c = getColor(p);
  convertColorToRGBFloat(c,r,g,b,a);
  //debugf("={ %f,%f,%f};\n",*r,*g,*b);
  return c;
}

unsigned int getColorRGB(unsigned char* r,unsigned  char*g, unsigned  char*b ,
                         char const * const p) 
{ 
  //debug("+getColorRGBFloat");
  unsigned int c;
  c = getColor(p);
  convertColorToRGB(c,r,g,b);
  //debugf("={ %f,%f,%f};\n",*r,*g,*b);
  return c;
}

//----------------------------------------------------------------------------
#if 0
int main(int argc,char* argv[])
{
  float r,g,b,a;
  unsigned int ui;
  char* pstr = "GREEN METAL";
  char* ce= "r010g020b230a000";
  
  r = g = b = a = 0;  
  convertColorStringToRGBAFloat( pstr, &r,&g,&b,&a,&ui);
  debugf("%s={%f,%f,%f,%f}=%u\n",pstr,r,g,b,a,ui);

  convertColorStringToRGBAFloat( ce, &r,&g,&b,&a,&ui);
  debugf("%s={%f,%f,%f,%f}=%u\n",ce,r,g,b,a,ui);
  return EXIT_SUCCESS;
}

#endif

#endif //_h_ 
//EOF $Id: color3ds.c,v 1.1.1.1 2004/03/30 12:09:25 rzr Exp $
