/**
 * All this should be replaced by use of transformation matrix
 * @author: www.Philippe.COVAL.online.fr - Rev: $Author: rzr $ 
 **/
#ifndef trace3d_h_
#define trace3d_h_
#include <assert.h>
#include "types3d.h"

void translateObject( Object *o, float x,float y, float z);

void placeObject( Object *o, float x,float y, float z);

void rotateAxisObject( Object *o, float x,float y, float z,float a);

void rotateObject( Object *o, float x,float y, float z);

void scaleObject(Object* o, float x, float y, float z);

void statsObject( Object* obj,
		  Vertex* lo, Vertex* hi, Vertex* mid, Vertex* center) ;

void printObject( Object* obj);

void stats( Vertex* vVertex, int nVertex,
	    Face* vFace, int nFace,
	    Vertex* lo, Vertex* hi, Vertex* mid, Vertex* center) ;

void statsSceneBox(Scene* s, Vertex* lo, Vertex* hi);

void scaleObjectInSphere( Object* o, float r);

void scaleSceneInSphere( Scene* o, float r);

void transformScene(Scene* in , Vertex const * const t, 
                    Vertex const * const r, Vertex const * const s) ;


void centerObject( Object*o);
//-----------------------------------
Vertex addVV( Vertex a, Vertex b);

Vertex subVV( Vertex a, Vertex b);

Vertex multVf(Vertex a, float arg);

Vertex minVV(Vertex a, Vertex b);

Vertex maxVV(Vertex a, Vertex b);
//-----------------------------------
/// 
void rotate( Vertex** vVertex, int nVertex, Vertex rot);
///
void translate( Vertex** vVertex, int nVertex, Vertex off);
///
void scaleInSphere( Vertex** v, int n, float r, Vertex lo, Vertex hi);
///
void scale( Vertex** vVertex, int nVertex, Vertex arg);
///
void project( Point** vPoint,
	      Vertex* vVertex, int nVertex,
	      Face* vFace, int nFace,
	      Vertex lo, Vertex hi,
	      int w, int h) ;

#endif

