/* #ident "$Id: types3d.c,v 1.1.1.1 2004/03/30 12:09:29 rzr Exp $" */
/**
 * @author: www.Philippe.COVAL.online.fr - Rev: $Author: rzr $ 
 * Copyright: GPL @ http://rzr.online.fr/licence.htm
 **/
#ifndef types3d_c_
#define types3d_c_

#include <stdlib.h>
#include "types3d.h"


void freeObject(Object* o)
{
  unsigned int i=0;
  for (i=0;i< o->nf;i++) {
    free ( o->vf[i].material );
  }
  free( o->vv); o->vv=0;
  free( o->vf); o->vv=0;
  initObject(o);
}

void initObject(Object* a)
{
  a->nv = 0; 
  a->nf = 0;  
  a->vf = 0;  
  a->vv = 0;  
  a->name = 0;
}

void initScene(Scene* s)
{
  //debug("+initScene");
  s->no = 0;
  s->vo = 0;
  initVertex( & (s->lightColorAmbiant) ); //!!
  //debug("-initScene");
}

void initFace(Face* s)
{
  s->a = s-> b = s->c = 0;
  s->material = 0;
}


void statsScene(Scene const * const s)
{
  debugf("%d",s->no);
  //debug("- statsScene");
}

void freeScene(Scene* s)
{
  unsigned int i=0;
  for(i=0;i< s->no; i++)
    freeObject( &(s->vo)[i]);
  
  if ( s->vo)   free( s->vo );
  initScene(s);
}

void initVertex(Vertex* v)
{
  v->x=0; v->y=0; v->z=0;
}
void printFace( Face const v)
{
  printf("{ { %d, %d, %d}; \n",v.a,v.b,v.c);
}

void printV( Vertex const v)
{
  printf("{ { %f, %f, %f} , { %f, %f} }; \n",v.x,v.y,v.z,v.u,v.v);
}
void printPoint(Point v)
{
  printf("{ %d, %d }; \n",v.x,v.y);
}
#endif // inclusion
