/* #ident "$Id: */
/**
 * @author: www.Philippe.COVAL.online.fr - Rev: $Author: rzr $ 
 * Copyright: GPL @ http://rzr.online.fr/licence.htm
 * This lib provide read/write 3ds object in ascii (.asc) and other utils
 * May merge in view3ds / lib3ds
 **/

#ifndef types3d_h_
#define types3d_h_

#ifdef __cplusplus
extern "C" {
#endif

#include "include.h"

typedef struct
{
  /// Coordinates
  float x, y, z;
  /// Tex corrds
  float u,v;
} Vertex;

typedef struct
{
  int x, y;
} Point;


/// Basic Face (a,b,c) + 3DS .asc oddities (may move to a material node)
typedef struct
{
  /// vertices indexes
  unsigned int a,b,c;
  /// unknown and unused so far (3DS .asc)
  unsigned int aa, ab, ac;
  /// face color 
  unsigned char col;
  /// material prop (unused so far)
  char smoothing;
  /// material name (texture name or rgb name)
  char *material;
} Face;


typedef struct
{
  Vertex* vv;
  Face*   vf;
  unsigned int nv;
  unsigned int nf;
  char * name;
} Object; //TriMesh

typedef struct
{
  Vertex lightColorAmbiant;
  Object* vo;
  unsigned int no;
} Scene;

void initObject(Object* a);

void freeObject(Object* o);

void freeScene(Scene* o);

void initScene(Scene* s);

void statsScene(Scene const * const s);

void initVertex(Vertex* v);

void printV( Vertex const v);

void printFace( Face const v);

#ifdef __cplusplus
}
#endif

#endif //_h_
/*
Face list
Face 0:  A:4 B:7 C:3 AB:1 BC:1 CA:1
Material:"BLUE"
Smoothing:  1
*/


/*
Ambient light color: Red=0.2 Green=0.2 Blue=0.2
*/
